module.exports = function (RED) {
    const {OPCUAClient, AttributeIds, TimestampsToReturn} = require('node-opcua');
    const client = OPCUAClient.create({endpointMustExist: false});
    const mqtt = require("mqtt");
    const NodeS7 = require('nodes7'); // This is the package name, if the repository is cloned you may need to require 'nodeS7' with uppercase S
    const conn = new NodeS7;
    let Session = null;
    let pattern = null;
    function rhein_data_acquisition(config) {
        RED.nodes.createNode(this, config);
        var node = this;
        let val = null;
        this.time = null;
        this.opcIP = config.opcIP
        this.Communication = config.Communication
        node.valObj = {};
        // this.status({fill:"blue",shape:"dot",text:"未连接设备"});//对节点已取消发送前端显示

        //node-red开始运行时，过几秒自动尝试连接
        let time = null;
        time = setTimeout(()=>{
            if (config.opcIP !== ''&& config.Communication === 'OPC UA'){
                client.on("backoff", (retry, delay) => {
                    console.log(`try to connect to ${this.opcIP} , retry ${retry} next attemt in ${delay / 1000} sec`)
                })
                client.connect(this.opcIP, (err) => {
                    if (err) {
                        console.log(`cannot connect to endpoint: ${this.opcIP}`)
                        node.status({fill:"red",shape:"dot",text:"OPC UA连接出现故障"});//对节点已取消发送前端显示
                    } else {
                        // clearInterval(tme)
                        console.log("connected !!")
                        node.status({fill:"green",shape:"dot",text:"OPC UA已连接"});//对节点已取消发送前端显示
                        CreateSession()
                        // callback()
                        //调用通道建立函数
                    }
                    // callback()
                });
                // this.theSession = null;
                function CreateSession() {
                    client.createSession((err, session) => {
                        if (err) {
                            // return
                        }
                        Session = session
                        // getVal(obj,session)
                        // callback()
                        //调用循环读取变量函数
                    })
                }
                // this.status({fill:"green",shape:"dot",text:"已连接设备，已采集数据"});//对节点已取消发送前端显示
            }else {
                node.status({fill:"green",shape:"dot",text:"S7已连接"});//对节点已取消发送前端显示
            }
        },3000)

        node.on('input', function (msg, done) { // 接收上游节点接收消息
            val = msg.payload;
            // node.warn(msg)
            // node.warn(val)
            let obj = {}
            for (let i in val){
                let temporaryObj = {}
                for (let v in val[i]){
                    if (v === 'nodeArr'){
                        val[i][v].forEach((valArr,q)=>{
                            temporaryObj[val[i].nodeValArr[q]] = valArr
                        })
                    }
                }
                obj[i] = temporaryObj;
            }
            // console.log(obj)
            // console.log(JSON.stringify(obj.controller) === '{}')//对的


            function getVal(obj,session){
                // let time = null;
                if (config.Communication === 'OPC UA') {
                    // clearInterval(time)
                    // time = setInterval(()=>{
                    for (let i in obj){
                        let temporaryObj = {}
                        if (JSON.stringify(obj[i]) !== '{}'){
                            // console.log(111)
                            for (let q in obj[i]){
                                // console.log(i,q,obj[i][q])
                                session.read({nodeId: obj[i][q], attributeId: AttributeIds.Value}, (err, dataValue) => {
                                    let obj1 = {}
                                    if (!err) {
                                        // opcVal[val] = dataValue.value.value;
                                        // // console.log(opcVal)
                                        // opcValDataTypeArr[val] = dataValue.value.dataType
                                        // console.log(dataValue.value);
                                        // // console.log(dataValue.value.dataType)
                                        // // console.log(opcValDataTypeArr)
                                        temporaryObj[obj[i][q]] = dataValue.value.value;
                                        node.valObj[i] = temporaryObj
                                    }
                                })
                            }
                        }else {
                            node.valObj[i] = {}
                        }
                    }
                    // console.log(valObj)
                    // },1000)
                }
                // console.log(valObj)
            }

            // console.log(getVal())
            if (config.opcIP !== ''&& config.Communication === 'OPC UA'){
                getVal(obj,Session)
                let msg = {payload:node.valObj }
                // console.log(node.valObj)
                node.send(msg)
                // this.status({fill:"green",shape:"dot",text:"已连接设备，已采集数据"});//对节点已取消发送前端显示
            }else if (config.opcIP !== ''&& config.Communication === 'S7'){
                node.status({fill:"blue",shape:"dot",text:"S7已连接正在读取"});//对节点已取消发送前端显示
                conn.initiateConnection({ port: 102, host: config.opcIP, rack: 0, slot: 1, debug: false }, connected);
                // let msg = {payload: node.valObj}
                // node.send(msg)
            }

            //--------------------------mqtt----------------------
            if (config.MQTTOff){
                mqttPub(config.mqttTopic,config.mqttServer,config.mqttQos,node.valObj)
            }
            function mqttPub(mqttTopic,mqttServer,mqttQos,pubVal){
                // let num = Number(mqttQos)
                // console.log(num)
                let clientMQTT = mqtt.connect('mqtt://'+mqttServer+':1883') // 连接到mqtt服务器
                // const value = Math.ceil(Math.random() * 40)
                clientMQTT.publish(mqttTopic, JSON.stringify(pubVal), {qos: Number(mqttQos), retain: true})
                // console.log("value：", JSON.stringify(value))
            }

            //----------------------S7----------------------------------

            function connected(){
                let S7i = 0;
                let S7tim = null;
                let temporaryObj = {};
                S7tim = setInterval(()=>{
                    // console.log(S7i)
                    if (S7i<Object.keys(obj).length){
                        if (JSON.stringify(obj[Object.keys(obj)[S7i]]) !== '{}'){
                            // let temporaryObj = {}
                            S7(obj[Object.keys(obj)[S7i]],(val)=>{
                                let valArr = Object.values(obj[Object.keys(obj)[S7i]])
                                let keyArr = Object.keys(obj[Object.keys(obj)[S7i]])
                                valArr.forEach((value,i)=>{
                                    val[valArr[i]] = val[keyArr[i]]
                                    delete val[keyArr[i]]
                                })
                                // console.log(val)
                                // console.log(S7i,Object.keys(obj)[S7i])
                                temporaryObj = val
                                // console.log(temporaryObj)
                                node.valObj[Object.keys(obj)[S7i]] = temporaryObj
                                S7i++
                                conn.removeItems()
                                // console.log(val)
                                // node.warn(val)
                            })
                            // if (off){S7i++}
                        }else {
                            node.valObj[Object.keys(obj)[S7i]] = {}
                            S7i++
                        }
                    }else {
                        clearInterval(S7tim)
                        S7i = 0;
                        conn.dropConnection()
                        let msg = {payload: node.valObj}
                        node.status({fill:"green",shape:"dot",text:"S7数据读取成功"});//对节点已取消发送前端显示
                        node.send(msg)
                        // console.log(node.valObj)
                    }
                },100)
            }


            function S7(variables,call){
                connected()
                // console.log(variables)
                function connected(err) {
                    if (typeof(err) !== "undefined") {
                        // We have an error. Maybe the PLC is not reachable.
                        console.log(err);
                        process.exit();
                    }
                    conn.setTranslationCB(function(tag) { return variables[tag]; }); // This sets the "translation" to allow us to work with object names
                    conn.addItems(Object.keys(variables));
                    conn.readAllItems((anythingBad, values)=>{
                        if (anythingBad) { console.log("SOMETHING WENT WRONG READING VALUES!!!!"); }
                        // console.log(values);
                        call&&call(values)
                    });
                }

            }
        });

        node.send({ // 向下一个节点输出信息

        });


    }
    // 注册一个节点 sum,注册的节点不能重复也就是说同一个 node-red 项目不能有 2 个 registerType sum 节点
    RED.nodes.registerType("rhein_data_acquisition", rhein_data_acquisition);
    rhein_data_acquisition.prototype.close = function() {
        // clearInterval(time);
        // client.on("backoff", (retry, delay) => {
        //     console.log(`try to connect to ${this.opcIP} , retry ${retry} next attemt in ${delay / 1000} sec`)
        // })
        // client.connect(this.opcIP, (err) => {
        //     if (err) {
        //         console.log(`cannot connect to endpoint: ${this.opcIP}`)
        //     } else {
        //         // clearInterval(tme)
        //         console.log("connected !!")
        //         CreateSession()
        //         // callback()
        //         //调用通道建立函数
        //     }
        //     // callback()
        // });
        // // this.theSession = null;
        // function CreateSession() {
        //     client.createSession((err, session) => {
        //         if (err) {
        //             // return
        //         }
        //         Session = session
        //         // getVal(obj,session)
        //         // callback()
        //         //调用循环读取变量函数
        //     })
        // }
        let node = this
        if (this.opcIP !== ''&& this.Communication === 'OPC UA'){
            node.status({fill:"blue",shape:"dot",text:"当前通讯:OPC UA"});//对节点已取消发送前端显示
            disCon()
        }else if (this.opcIP !== ''&& this.Communication === 'S7'){
            node.status({fill:"blue",shape:"dot",text:"当前通讯:S7"});//对节点已取消发送前端显示
        }
        console.log(pattern)
        function disCon(){
            console.log(" closing session");
            Session.close(function (err) {
                console.log(" session closed");
                node.status({fill:"blue",shape:"dot",text:"OPC UA已断开连接"});//对节点已取消发送前端显示
                client.disconnect(function () {});
                // callback();
            });
        }

    };
}
